// PatchWorks 1.0 Image GetAverageColor File
// This Software is released under the terms of the GPL.

// calculates the average color of a bitmap
// Maintainer: Daniel Stiefelmaier


#include "Image.h"


int GetAverageColor(sImage *image)
{
	uint i;
	uint imgsize;

	double avgc_b = 0;
	double avgc_g = 0;
	double avgc_r = 0;

	//imgsize = sizeof(image->data);
	//if(imgsize%3 != 0)					return 1;	// illegal image data size
	//if(imgsize != 3*image->w*image->h)	return 1;
	imgsize = 3*image->w*image->h;

	// this implementation works for images with
	// up to 16843009 pixels (4104*4104 pixels) -> PATCH_RES_MAXIMUM

	for(i=0; i<imgsize; i++)
	{
		switch(i%3)
		{
			case 0:	avgc_b += image->data[i]; break;
			case 1:	avgc_g += image->data[i]; break;
			case 2:	avgc_r += image->data[i]; break;
		}
	}

	imgsize /= 3;		// size of one channel

	image->avgc_b = (int)(avgc_b / imgsize + 0.5); // add 0.5 to floor/ceil
	image->avgc_g = (int)(avgc_g / imgsize + 0.5);
	image->avgc_r = (int)(avgc_r / imgsize + 0.5);

	return 0;
}