// header file for defines

#ifndef DEFINES_H
#define DEFINES_H


#define _APPNAME "PatchWorks"
#define _VERSION "1.0"

#define PATCH_RES_DEFAULT	32	// Default Patch Resolution in pixels
#define PATCH_RES_MINIMUM	1
#define PATCH_RES_MAXIMUM	4104
#define PATCH_DPI_DEFAULT	100
#define PATCH_DPI_MINIMUM	10		// von Steven zu setzen/prfen
#define PATCH_DPI_MAXIMUM	16000	// von Steven zu setzen

#define FILELIST_END		"???END_OF_FILE_LIST???"
#define DB_INDEX_FILE		"DBindex.dbi"
#define DB_FILE_LEN			12	// img00001.bmp
#define INDEX_FILE_LINE		25	// bytes per line in DB index file
#define MAX_OPEN_DBs		10
#define MAX_IMAGES			99999 // max images per DB

// System Specific
#ifdef macintosh
#define DIR_SEP		":"
#define DIR_SEP_C	':'
#else
#define DIR_SEP		"/"
#define DIR_SEP_C	'/'
#endif



#define APP_LANG_EN // application language english

// Errorcodes

// Prefix Syntax:
// Error:	er[x]_ with x = return code
// Info:	info_


#ifdef APP_LANG_EN

#define eINTERNAL_ERROR			"\nUnexpected internal error."
#define eNO_MEMORY				"\nNot enough memory or other internal error."
#define eNOT_A_DIR				"\nCould not access directory. May be not a valid path."
#define eNOT_DELETED			"\nCould not delete file."

#define err1 "\nNot enough Parameter or wrong Syntax"
#define err2 "\nNot enough Parameter for -deldb"
#define err4 "\nDatabase already exist\n"
#define err3 "\nDelete Database [y|n] :"
#define err5 "\nParamter %i (Force) wrong Syntax"
#define err6 "\nreadindex failure code %i"
#define err7 "\ncreateIndexFile failure code %i"
#define err8 "\nNot enough Parameter for -newdb"
#define err9 "\nNot enough Parameter for -subdb"
#define err10 "\nDatabase item deleted"
#define err11 "\nNot enough Parameter for -adddb"
#define err12 "\nreadimage failure code %i"
#define err13 "\nscaleimage failure code %i"
#define err14 "\nGetAverageColor failure code %i"
#define err15 "\nWriteImage failure code %i"
#define err16 "\nto much parameter for pseudo patchwork"
#define err17 "\nPseudoPatchwork created"
#define err18 "\nTo much Parameter ;)"
#define err19 "\nDatabase closed"
#define err20 "\nDatabase opened"
#define err21 "\nDelete Database item [y|n] :"
#define err22 "\nDatabase item already exist"
#define err23 "\nCheck your Parameter Syntax!\nFor help type: pw /?"
#define err24 "\nCould not allocate memory for abcLOWER fkt" 
#define err25 "\nFindFittingPatch failure code %i"
#define err26 "\nNo DB in use"
#define err27 "\nPatchwork created"

#define err1_OpenDB "\nToo many DBs open"
#define err2_OpenDB eNO_MEMORY
#define err3_OpenDB eNOT_A_DIR

#define err1_CloseDB "\nDB already closed or has not been in use"
#define err2_CloseDB "\nUnsaved changes! Save, or reset changes (changed=0) to override."
#define err3_CloseDB "\nCloseDB failure code %i"


#define err1_SaveDB "\nDB not in use. Cannot save."
#define err2_SaveDB "\nNo changes to save."
#define err3_SaveDB eNO_MEMORY
#define err4_SaveDB eNOT_A_DIR
#define err5_SaveDB eNOT_DELETED
#define err6_SaveDB "\nCould not create file."

#define err1_AddDB "\nIllegal resolution."
#define err2_AddDB eNO_MEMORY
#define err3_AddDB "\nDirectory already exists! Choose another name."
#define err4_AddDB "\nCouldn't create directory!\nCheck HDD space and permissions. Or try a different name"

#define err1_DeleteDB "\nDB not in use. Cannot close."
#define err2_DeleteDB "\nUnsaved changes! Save, or reset changes (changed=0) to override."
#define err3_DeleteDB "\nCould not delete (all) items in folder."
#define err4_DeleteDB "\nCould not remove folder."

#define err1_AddDBItem eNO_MEMORY
#define err2_AddDBItem "\nIllegal database specified."
#define err3_AddDBItem "\nDB is full."
#define err4_AddDBItem eINTERNAL_ERROR
#define err9_AddDBItem "\nNot all images have been added:\nSome were to small (upscale is currently not supported)"

#define err1_DeleteDBItem eINTERNAL_ERROR

#define err1_GetAverageColor	"\nIncorrect size of imagedata: Size must be divisible by 3"

#define info_DONT_EDIT			"Warning! Do not edit this file manually! Editing WILL make this DataBase worthless!"

#define help "\nParametersyntax:\nCreate Patchwork:\nsource.bmp target.bmp patchDB1 ... patchDB10\n\nCreate Pseudopachwork:\nsource.bmp target.bmp pseudo [Colorcount] [[Resolution]]\n\nCreate New Database:\n-newdb [DBpath/]name [Auflsung [DPI]]\n\nAdd item to Database:\n-addDB [DBpath/]name path[/xxxx.bmp]\n\nSubtract item from Database:\n-subDB [DBpath/]name path/xxxx.bmp [Force]\n\nDelete Database:\n-delDB [DBpath/]name [Force]\n\n"

#endif





#endif