// PatchWorks 1.0 Main Console File
// This Software is released under the terms of the GPL.

// Console Interface
// Maintainer: Philipp Scharpf

#include "_main.h"
#include "FileSysHelp.h"

int Console(int argc, char *argv[])
{
	//int maxparameter=3+MAX_OPEN_DBs;

	sDataBase DataBase[MAX_OPEN_DBs] = {0}; // a maximum of MAX_OPEN_DBs Databases kann be open at the same time
	int i,err,res,dpi,cC;
	char answer,*argvcopy;
	clock_t starttime, stoptime, time_ms;
	double time_s;


	if (argc==2)
	{
		if (strstr(argv[1],"?")!=NULL)
		{
			printf(help);
			return 0;
		}
		//printf(err1);
		//return 1; //zuweninge parameter angegeben
	}
	argvcopy = malloc(strlen(argv[1])+2);
	if ( argvcopy == NULL ) 
	{
		printf(err24);
		return 1;
	}
	strcpy (argvcopy,argv[1]);
	abcLOWER(argvcopy);



	if (strcmp(argvcopy , "-deldb" ) ==0)
	{
		if(argc<3) 
		{
			printf(err2);
			return 1; //zuwenig para fuer deldb
		}
		if(argc==3)
		{
			do
			{

				printf(err3);//abfrage ob db geloescht werden soll JA NEIN
				scanf("%c",&answer);
			}
			while ((answer!='y') && (answer!='Y') && (answer!='n') && (answer!='N'));

			if ((answer=='n')||(answer=='N'))
			{
				//datenbank nicht loeschen
				printf(err4);//angabe der Db fehlt noch, welche geloescht wurde
				return 1; 
			}


		}
		if(argc==4)
		{
			if (strcmp (argv[3],"Force") != 0) //wenn force nicht korrekt angeben
			{
				printf(err5,argc);
				return 1;
			}

		}

		//Datenbank loeschen mit abfrage=yes oder mir FORCE
		err=OpenDB(DataBase, argv[2]); //openDB fehler 1-3 od 11-18
		if ((err>10)&&(err<20)) //alle fehler zwischen 10 und 20 stammen von readindexfile 11-18
		{
			printf(err6,err);//readindex failure
			return 1;
		}
		else
		{
			switch( err )
			{
			case 1:printf(err1_OpenDB);return 1;// To many DBs open
			case 2:printf(eNO_MEMORY);return 1;// not enough memory?
			case 3:printf(eNOT_A_DIR);return 1;// could not access directory
			default: break; //db geoffnet
			}
		}
		err=DeleteDB(DataBase, 0); //DeleteDB fehler 1-4 od 11-12
		if ((err>10)&&(err<20))//alle fehler zwischen 10 und 20 stammen von closeDB 11-18
		{
			printf(err3_CloseDB,err);//closeDB failure code %i
			return 1;
		}
		else
		{
			switch( err )
			{
			case 1:printf(err1_DeleteDB);return 1;// already closed / not in use
			case 2:printf(err2_DeleteDB);return 1;//unsaved changes! save, or set changed=0 to override
			case 3:printf(err3_DeleteDB);return 1;//could not delete (all) items in folder
			case 4:printf(err4_DeleteDB);return 1;//could not remove folder
			default:printf("\nDatenbank wurde geloescht");
			}
		}
	}

	//########################################################################################################

	else if (strcmp ( argvcopy , "-newdb" ) ==0)
	{
		if (argc<3) 
		{
			printf(err8);
			return 1; //zuwenig para fuer newdb
		}
		if(argc==3)
		{
			err=AddDB(argv[2], PATCH_RES_DEFAULT, PATCH_RES_DEFAULT, PATCH_DPI_DEFAULT);//addDB fehler 1-4 od 11-12
			if ((err>10)&&(err<20))//alle fehler zwischen 10 und 20 stammen von createIndexFile 11-12
			{
				printf(err7,err);//createIndexFile failure
				return 1;
			}
			else
			{

				switch( err )
				{
				case 1:printf(err1_AddDB);return 1;// illegal resolution
				case 2:printf(err2_AddDB);return 1;// not enough meomory
				case 3:printf(err3_AddDB);return 1;// already exists
				case 4:printf(err4_AddDB);return 1;// couldn't create
				default:printf("\nDatenbank wurde angelegt");
				}
			}


		}
		else if(argc==4)
		{

			sscanf(argv[3],"%i",&res);
			err=AddDB(argv[2], res, res, PATCH_DPI_DEFAULT);//erstellen von db mit aufloesung und default dpi

			if ((err>10)&&(err<20))//alle fehler zwischen 10 und 20 stammen von createIndexFile 11-12
			{
				printf(err7,err);//createIndexFile failure
				return 1;
			}
			else
			{
				switch( err )
				{
				case 1:printf(err1_AddDB);return 1;// illegal resolution
				case 2:printf(err2_AddDB);return 1;// not enough meomory
				case 3:printf(err3_AddDB);return 1;// already exists
				case 4:printf(err4_AddDB);return 1;// couldn't create
				default:printf("\nDatenbank wurde angelegt");
				}
			}


		}
		else if(argc==5)
		{
			//erstellen von db mit angegeben werten
			sscanf(argv[3],"%i",&res);
			sscanf(argv[4],"%i",&dpi);
			err=AddDB(argv[2], res, res, dpi);

			if ((err>10)&&(err<20))//alle fehler zwischen 10 und 20 stammen von createIndexFile 11-12
			{
				printf(err7,err);//createIndexFile failure
				return 1;
			}
			else
			{
				switch( err )
				{
				case 1:printf(err1_AddDB);return 1;// illegal resolution
				case 2:printf(err2_AddDB);return 1;// not enough meomory
				case 3:printf(err3_AddDB);return 1;// already exists
				case 4:printf(err4_AddDB);return 1;// couldn't create
				default:printf("\nDatenbank wurde angelegt");
				}
			}


		}


	}

	//#####################################################################################################
	else if (strcmp ( argvcopy , "-subdb" ) ==0)
	{
		if (argc<4) 
		{
			printf(err9);
			return 1; //zuwenig para fuer subdb
		}
		if(argc==4)
		{
			do
			{

				printf(err21);//abfrage ob dbeintrag geloescht werden soll JA NEIN
				scanf("%c",&answer);
			}
			while ((answer!='y') && (answer!='Y') && (answer!='n') && (answer!='N'));

			if ((answer=='n')||(answer=='N'))
			{
				//datenbankeintrag nicht loeschen
				printf(err22);//angabe der Db fehlt noch, welche geloescht wurde
				return 1; 
			}


		}
		if(argc==5)
		{
			if (strcmp (argv[4],"Force") != 0) //wenn force nicht korrekt angeben
			{
				printf(err5,argc);
				return 1;
			}

		}
		//Datenbankeintrag loeschen mit abfrage=yes oder mir FORCE
		err=OpenDB(DataBase, argv[2]); //openDB fehler 1-3 od 11-18
		if ((err>10)&&(err<20)) //alle fehler zwischen 10 und 20 stammen von readindexfile 11-18
		{
			printf(err6,err);//readindex failure
			return 1;
		}
		else
		{
			switch( err )
			{
			case 1:printf(err1_OpenDB);return 1;// To many DBs open
			case 2:printf(eNO_MEMORY);return 1;// not enough memory?
			case 3:printf(eNOT_A_DIR);return 1;// could not access directory
			default: break; //db geoffnet
			}
		}

		err=DeleteDBItem(DataBase, argv[3]);
		if ((err>10)&&(err<20))//alle fehler zwischen 10 und 20 stammen von closeDB 11-18
		{
			printf(err3_CloseDB,err);//closeDB failure
			return 1;
		}
		else
		{
			switch( err )
			{
			case 1:printf(err1_DeleteDB);return 1;//
			case 2:printf(err2_DeleteDB);return 1;//
			case 3:printf(err3_DeleteDB);return 1;//
			case 4:printf(err4_DeleteDB);return 1;//
			default:printf("\nDatenbankeintrag wurde geloescht");
			}
		}

		printf(err10); //angabe der Db fehlt noch, welche geloescht wurde

	}

	//###########################################################################################################

	else if (strcmp ( argvcopy , "-adddb" ) ==0)
	{
		if (argc<4)
		{
			printf(err11);
			return 1; //zuwenig para fuer adddb
		}


		if (argc==4)
		{
			err=OpenDB(DataBase, argv[2]); //openDB fehler 1-3 od 11-18
			if ((err>10)&&(err<20)) //alle fehler zwischen 10 und 20 stammen von readindexfile 11-18
			{
				printf(err6,err);//readindex failure
				return 1;
			}
			else
			{
				switch( err )
				{
				case 1:printf(err1_OpenDB);return 1;// To many DBs open
				case 2:printf(eNO_MEMORY);return 1;// not enough memory?
				case 3:printf(eNOT_A_DIR);return 1;//was geht hier
				default: break; //db geoffnet
				}
			}

			err=AddDBItems(argv[3], DataBase);
			if ((err>10)&&(err<20))//alle fehler zwischen 10 und 20 stammen von readimage
			{
				printf(err12,err);//readimage failure
				return 1;
			}
			else if ((err>20)&&(err<30))//alle fehler zwischen 10 und 20 stammen von ScaleImage
			{
				printf(err13,err);//scaleImage failure
				return 1;
			}
			else if ((err>30)&&(err<40))//alle fehler zwischen 10 und 20 stammen von GetAverageColor
			{
				printf(err14,err);//GetAverageColor failure
				return 1;
			}
			else if ((err>40)&&(err<50))//alle fehler zwischen 10 und 20 stammen von WriteImage
			{
				printf(err15,err);//WriteImage failure
				return 1;
			}
			else
			{


				switch( err )
				{
				case 1:printf(err1_AddDBItem);return 1;//not enough memory
				case 2:printf(err2_AddDBItem);return 1;//illegal database specified
				case 3:printf(err3_AddDBItem);return 1;//DB is full
				case 4:printf(err4_AddDBItem);return 1;//internal error
				case 8:printf(err1_AddDBItem);return 1;//not enough memory
				case 9:printf(err9_AddDBItem);
				default:printf("\nDatenbase has been updated.");
				}
			}
			err=SaveDB(DataBase, 0);
			if ((err>10)&&(err<20))//alle fehler zwischen 10 und 20 stammen von CreateIndexFile
			{
				printf(err7,err);//CreateindexFile failure
				return 1;
			}
			else
			{
				switch (err)
				{
				case 1:printf(err1_SaveDB);return 1;//DB not in use
				case 2:printf(err2_SaveDB);return 1;//no changes to save
				case 3:printf(err3_SaveDB);return 1;//not enough memory?
				case 4:printf(err4_SaveDB);return 1;//directory does not exist?
				case 5:printf(err5_SaveDB);return 1;//could not delete file
				case 6:printf(err6_SaveDB);return 1;//could not create file
				default:printf("\nDatabase has been successfully saved.");
				}
			}


			//aufruf adddb
		}

	}

	//##############################################################################################################

	else // (PSEUDO) Patchwork erzeugen
	{
		free( argvcopy );
		argvcopy = malloc(strlen(argv[3])+2);
		if ( argvcopy == NULL ) 
		{
			printf(err24);
			return 1;
		}
		strcpy (argvcopy,argv[3]);
		abcLOWER(argvcopy);

		if(argc >= 4)
		{
			if( strcmp ( argvcopy, "pseudo" ) ==0 )
			{
				if     (argc >  6) printf(err16); //to much parameter for pseudo
				else if(argc == 6)
				{
					sscanf(argv[4],"%i",&cC);
					sscanf(argv[5],"%i",&res);
					if ((res<=PATCH_RES_MINIMUM)||(res>=PATCH_RES_MAXIMUM))//PATCH_RES_MINIMUM=1 PATCH_RES_MAXIMUM=4104
					{
						printf(err1_AddDB);//Fehler
						return 1;
					}

					printf("\ncalculating..."); //zeitrechenfkt
					starttime = clock();

					err=CreatePseudoPatchwork(argv[1], argv[2], res, res, cC);
					switch (err)
					{
					case 1:printf(eNO_MEMORY);return 1;//not enough memory
					default:printf(err17);break;
					}

					stoptime = clock();
					time_ms = stoptime - starttime;
					time_s = time_ms / 1000.0;
					printf("\nElapsed time: %10.3lf seconds", time_s); //auswertung zeitrechenfkt

					// ... pseudo ANZAHL_FARBEN PATCHGROESSE
					// (patchgre berprfen
				}
				else if(argc == 5)
				{
					sscanf(argv[4],"%i",&cC);

					printf("\ncalculating..."); //zeitrechenfkt
					starttime = clock();

					err=CreatePseudoPatchwork(argv[1], argv[2], PATCH_RES_DEFAULT, PATCH_RES_DEFAULT, cC);
					switch (err)
					{
					case 1:printf(eNO_MEMORY);return 1;//not enough memory
					default:printf(err17);break;
					}

					stoptime = clock();
					time_ms = stoptime - starttime;
					time_s = time_ms / 1000.0;
					printf("\nElapsed time: %10.3lf seconds", time_s); //auswertung zeitrechenfkt

					// ... pseudo ANZAHL_FARBEN 
					// => default patch gre
				}
				else // argc == 4
				{
					sscanf(argv[3],"%i",&cC);

					printf("\ncalculating..."); //zeitrechenfkt
					starttime = clock();

					err=CreatePseudoPatchwork(argv[1], argv[2], PATCH_RES_DEFAULT, PATCH_RES_DEFAULT, cC);
					switch (err)
					{
					case 1:printf(eNO_MEMORY);return 1;//not enough memory
					default:printf(err17);break;
					}

					stoptime = clock();
					time_ms = stoptime - starttime;
					time_s = time_ms / 1000.0;
					printf("\nElapsed time: %10.3lf seconds", time_s); //auswertung zeitrechenfkt


					// aufruf pseudo ohne angaben
				}
			}
//#########################################################################################################
			else // kein pseudo, normales PW
			{

				// berflssig: wir haben min 4 parameter.
				//if (argc==3) return 1;//zuwenig parameter fr datenbanken oeffnen
				if ((argc-3)>MAX_OPEN_DBs )
				{
					printf(err18);
					return 1; //zuviel parameter fuer Datenbanken angegeben
				}
				for (i=4;i<=argc;i++)
				{
					err=OpenDB(DataBase, argv[i-1]); //openDB fehler 1-3 od 11-18
					if ((err>10)&&(err<20)) //alle fehler zwischen 10 und 20 stammen von readindexfile 11-18
					{
						printf(err6,err);//readindex failure
						return 1;
					}
					else 
					{
						switch( err )
						{
						case 1:printf(err1_OpenDB);return 1;// To many DBs open
						case 2:printf(eNO_MEMORY);return 1;// not enough memory?
						case 3:printf(eNOT_A_DIR);return 1;//was geht hier
						default: printf(err20);break; //db geoffnet
						}
					}
					// open dbs von 1-10

				}
				for (i=0;i<=(argc-4);i++)//DB res_h und res_w vergleich , schliessen bei ungleich
				{
					if( (DataBase[0].res_h != DataBase[i].res_h) || (DataBase[0].res_w != DataBase[i].res_w) )
					{
						err=CloseDB(DataBase, i);
						switch (err)
						{
						case 1:printf(err1_CloseDB);return 1;// already closed / not in use
						case 2:printf(err2_CloseDB);return 1;// unsaved changes! save, or set changed=0 to override
						default:printf(err19);break;//Datenbank geschlossen
						}
					}
				}
				printf("\ncalculating..."); //zeitrechenfkt
					starttime = clock();
				
					err=CreatePatchwork(argv[1], argv[2], DataBase);

				if ((err>10)&&(err<20))//alle fehler zwischen 10 und 20 stammen von readimage
				{
					printf(err12,err);//readimage failure
					return 1;
				}
				else if ((err>20)&&(err<30))//alle fehler zwischen 10 und 20 stammen von FindFittingPatch
				{
					printf(err25,err);//FindFittingPatch failure
					return 1;
				}
				else if ((err>30)&&(err<40))//alle fehler zwischen 10 und 20 stammen von ReadImage
				{
					printf(err12,err);//ReadImage failure
					return 1;
				}
				else
				{


					switch( err )
					{

					case 2:printf(err26);return 1;// No DB in use
					case 3:printf(eNO_MEMORY);return 1;// not enough memory

					default:printf(err27);
					}
					
					stoptime = clock();
					time_ms = stoptime - starttime;
					time_s = time_ms / 1000.0;
					printf("\nElapsed time: %10.3lf seconds", time_s); //auswertung zeitrechenfkt

				}
				//Fehlerrueckgabe fuer createpatchwork


			}



		}
		else // ende gelnde, user hat verschissen
		{
			printf(err23);
			return 1;

		}
	}
	free( argvcopy );
	return 0;
}




/*
int Console(int argc, char *argv[])
{

	int CreatePseudoPatchwork(char *, char *, uint, uint, uint);

	int i=0;
	int err;
	
	clock_t starttime, stoptime, time_ms;
	double time_s;

	if(argc < 4)
	{
		printf("mongo du \n");
		return 5555;
	}
	if( strcmp(argv[3], "pseudo") == 0 )
	{
		printf("calculating...\n");
		starttime = clock();
		
		err = CreatePseudoPatchwork(argv[1], argv[2], 4, 4, 10000);
		printf("Errorcode %i \n", err);
		
		stoptime = clock();
		time_ms = stoptime - starttime;
		time_s = time_ms / 1000.0;
		printf("Elapsed time: %10.3lf seconds", time_s);
	}


	// parameter auf Konformitt prfen, passende Funktion aufrufen (falls Funktion bereits vorhanden)

 return 0;
}
*/
/*
Parameterformen:

  Patchwork erstellen:
  pw.exe quelle.bmp ziel.bmp patchDB1 patchDB2 patchDB3 ...

  PseudoPatchwork erstellen:
  pw.exe quelle.bmp ziel.bmp PSEUDO 

  DataBase erstellen
			Wird Auflsung nicht angegeben, wird der Standardwert DEFAULT_PATCH_RES verwendet.
			Beachten:	PATCH_RES_DEFAULT, PATCH_RES_MINIMUM, PATCH_RES_MAXIMUM
						PATCH_DPI_DEFAULT, PATCH_DPI_MINIMUM, PATCH_DPI_MAXIMUM
			Wird DBpath nicht angegeben, wird die DB in %APPDATA%/_APPNAME angelegt (Win, Philippe fragen fr Linux ( ~/_APPNAME vielleicht?)
  pw.exe -newDB [DBpath/]name [Auflsung [DPI]]

  DataBase erweitern (um Datei/Ordner)
  pw.exe -addDB [DBpath/]name path[/xxxx.bmp]

  DataBase ausmisten (um Datei) (Sicherheitsabfrage, unterdrckbar mit 2. Parameter)
  pw.exe -subDB [DBpath/]name path/xxxx.bmp [FORCE]

  DataBase lschen (Sicherheitsabfrage, unterdrckbar mit 2. Parameter)
  pw.exe -delDB [DBpath/]name [FORCE]

  Fehlermeldungen in der Form FUNKTIONSNAME FEHLERNR(=Rckgabewert)\n FEHLERSTRING\n\n
  bsp.
  GetAverageColor Error Code 1:
  er1_gIMG_INVALID_DATA


*/